<?php
/*
 * **********************************************************

 * Component Name: Mac-Dock Gallery
 * Description: Mac dock photo gallery component for Joomla 1.5, 1.6, 1.7 & 2.5
 * Version: 1.5
 * Edited By: Sameera
 * Author URI: http://www.apptha.com/
 * Date : November 20 2012

 * *********************************************************

  @Copyright Copyright (C) 2012-2013 Apptha Support
  @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

 * ******************************************************** */

// no direct access
defined('_JEXEC') or die('Restricted Access');
jimport('joomla.filesystem.folder');
jimport('joomla.installer.installer');
jimport( 'joomla.environment.uri' );

//<!-- for joomla 1.6 installtion process -->
class com_macgalleryInstallerScript
{
		function install($parent) 
		{
			$db = & JFactory::getDBO();
	       
			// $parent is the class calling this method		
	        $query = 'UPDATE  #__modules '.
	                 'SET published=1, ordering=0, position = "position-7" '.
	                 'WHERE module = "mod_macgallery"';
	        $db->setQuery($query);
	        $db->query();
	        
		}
	 
		/**
		 * method to uninstall the component
		 *
		 * @return void
		 */
		function uninstall($parent) 
		{
			$db = & JFactory::getDBO();
			// $parent is the class calling this method
			if(JFolder::exists(JPATH_ROOT.DS.'modules'.DS.'mod_macgallery'))
			{
				// 	delete a folder inside your module folder
				JFolder::delete(JPATH_ROOT.DS.'modules'.DS.'mod_macgallery');
			}  
			if(JFolder::exists(JPATH_ROOT.DS.'images'.DS.'macgallery'))
			{
				// delete a folder inside your module folder
				JFolder::delete(JPATH_ROOT.DS.'images'.DS.'macgallery');
			} 
			if(JFolder::exists(JPATH_ROOT.DS.'plugins'.DS.'macgallery'))
			{
				// 	delete a folder inside your module folder
				JFolder::delete(JPATH_ROOT.DS.'plugins'.DS.'macgallery');
			} 
			
			$query = "DELETE FROM #__extensions WHERE element = 'mod_macgallery' limit 1";
			$db->setQuery($query);
			$db->query();
			
			
					
			$query = "DELETE FROM #__extensions WHERE element = 'macgallery' limit 1";
			$db->setQuery($query);
			$db->query();
		}
	 
		/**
		 * method to update the component
		 *
		 * @return void
		 */
		function update($parent) 
		{
			// $parent is the class calling this method
		}
	 
		/**
		 * method to run before an install/update/uninstall method
		 *
		 * @return void
		 */
		function preflight($type, $parent) 
		{

		}
	 
		/**
		 * method to run after an install/update/uninstall method
		 *
		 * @return void
		 */
		function postflight($type, $parent) 
		{
			// $parent is the class calling this method
			// $type is the type of change (install, update or discover_install)
			
			$db = & JFactory::getDBO();
			$installer = new JInstaller();
			?>
			<img src="<?php echo JURI::base()."components/com_macgallery/assets/ok.png"; ?>"  /> Photo Gallery (Mac Dock Effect) - Component installed successfully<br/>
			<?php 
			//Installing the modules from extension folder
			if($installer->install(JPATH_BASE.DS.'components'.DS.'com_macgallery'.DS.'extensions'.DS.'mod_macgallery')){
			?>
				<img src="<?php echo JURI::base()."components/com_macgallery/assets/ok.png"; ?>"  /> Photo Gallery (Mac Dock Effect) - Module installed successfully<br/>
			<?php 
			}
			//Installing the plugin from the extension folder
			if($installer->install(JPATH_BASE.DS.'components'.DS.'com_macgallery'.DS.'extensions'.DS.'macgallery')){
			?>
				<img src="<?php echo JURI::base()."components/com_macgallery/assets/ok.png"; ?>"  /> Photo Gallery (Mac Dock Effect) - Plugin installed successfully<br/>
			<?php 
			}
			
			if(version_compare(JVERSION,'1.7.0','ge')) {
				$query = 'UPDATE  #__menu '.
	                 'SET alias = "Apptha Mac Dock photo Gallery" '.
	                 'WHERE title = "COM_MACGALLERY_JOOMLAMENU_PHOTOGALLERY"';
	         		$db->setQuery($query);
	        		$db->query();

	        		$query = 'UPDATE  #__menu '.
                			 'SET alias = "Images" '.
               			  'WHERE title = "COM_MACGALLERY_JOOMLAMENU_IMAGES"';
		   	     $db->setQuery($query);
		   	     $db->query();

		     	   $query = 'UPDATE  #__menu '.
		                 'SET alias = "Gallery Settings" '.
		                 'WHERE title = "COM_MACGALLERY_JOOMLAMENU_GALLERY_SETTINGS"';
		     	   $db->setQuery($query);
		     	   $db->query();

		     	   $query = 'UPDATE  #__menu '.
		                 'SET alias = "Control Panel" '.
		                 'WHERE title = "COM_MACGALLERY_JOOMLAMENU_CPANEL"';
		       	 $db->setQuery($query);
		       	 $db->query();

		        	 $query = 'UPDATE  #__menu '.
		                 'SET alias = "Albums" '.
		                 'WHERE title = "COM_MACGALLERY_JOOMLAMENU_ALBUMS"';
		       	  $db->setQuery($query);
	        		 $db->query();

			}
			else if(version_compare(JVERSION,'1.6.0','ge')){
	        	$query = 'UPDATE  #__menu '.
	                 'SET alias = "Apptha Mac Dock photo Gallery" '.
	                 'WHERE title = "COM_MACGALLERY_JOOMLAMENU_PHOTOGALLERY"';
	        	$db->setQuery($query);
	        	$db->query();

	        	$query = 'UPDATE  #__menu '.
                 'SET alias = "Images" '.
                 'WHERE title = "COM_MACGALLERY_JOOMLAMENU_IMAGES"';
		        $db->setQuery($query);
		        $db->query();

		        $query = 'UPDATE  #__menu '.
		                 'SET alias = "Gallery Settings" '.
		                 'WHERE title = "COM_MACGALLERY_JOOMLAMENU_GALLERY_SETTINGS"';
		        $db->setQuery($query);
		        $db->query();

		        $query = 'UPDATE  #__menu '.
		                 'SET alias = "Control Panel" '.
		                 'WHERE title = "COM_MACGALLERY_JOOMLAMENU_CPANEL"';
		        $db->setQuery($query);
		        $db->query();

		         $query = 'UPDATE  #__menu '.
		                 'SET alias = "Albums" '.
		                 'WHERE title = "COM_MACGALLERY_JOOMLAMENU_ALBUMS"';
		         $db->setQuery($query);
	        	 $db->query();
			}
	        
	        ?>
	        <style>
				table.adminform th{padding:0px;}
			</style>
			<div style="/* Opera 11.10+ */
				background: -o-linear-gradient(top, rgba(255,255,255,1), rgba(232,232,232,1));
			
				/* Firefox 3.6+ */
				background: -moz-linear-gradient(top, rgba(255,255,255,1), rgba(232,232,232,1));
				
				/* Chrome 7+ & Safari 5.03+ */
				background: -webkit-gradient(linear, left top, left bottom, color-stop(0, rgba(255,255,255,1)), color-stop(1, rgba(232,232,232,1)));
				
				/* IE5.5 - IE7 */
				filter: progid:DXImageTransform.Microsoft.Gradient(GradientType=0,StartColorStr=#FFFFFFFF,EndColorStr=#FFE8E8E8);
				
				/* IE8 */
				-ms-filter: progid:DXImageTransform.Microsoft.Gradient(GradientType=0,StartColorStr=#FFFFFFFF,EndColorStr=#FFE8E8E8);">
			<p style="font-style:normal;font-size:13px;font-weight:normal; ">
			<a href="http://www.apptha.com" target="_blank">Apptha</a> Photo Gallery (Mac Dock Effect) is integrated with mac doc and smooth Gallery effect giving your image gallery a classy look with Image slideshow effect. Apptha Photo Gallery (Mac Dock Effect) emulate a set of photos in very attractive and customizable galleries.</p>
		    <div style="margin-left:10px;padding-bottom:10px;">
		        <a href="https://www.apptha.com/downloadable/download/sample/sample_id/17/">Click here to download the documentation</a><br/>
		    </div>
		    </div>
	        <?php						
		}
}
?>
